//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class HaleChange extends CharacterChange
{
    hale = null;
    function CheckTeam()
    {
        hale = player;
        return IsHale(player);
    }
    function ShouldBreakDamageLoop(damage_type) { return damage_type == 1 || damage_type == 2; }
}

IncludeScript("vssaxtonhale/hale/hale_abilities/brave_jump.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/charge.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/mighty_slam.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/saxton_punch.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/stun_breakout.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/debuff_resistance.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/wide_punch.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/received_damage_scaling.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/taunt_handler.nut");

function CreateAoE(center, radius, applyDamageFunc, applyPushFunc)
{
    foreach(target in GetAliveMercs())
    {
        local deltaVector = target.GetCenter() - center;
        local distance = deltaVector.Norm();
        if (distance > radius)
            continue;

        applyPushFunc(target, deltaVector, distance);
        applyDamageFunc(target, deltaVector, distance);
    }

    local target = null;
    while (target = Entities.FindByClassname(target, "obj_*"))
    {
        local deltaVector = target.GetCenter() - center;
        local distance = deltaVector.Norm();
        if (distance > radius)
            continue;

        applyDamageFunc(target, deltaVector, distance);
    }
}

::HalePlayViewModelAnim <- function(animation)
{
    local main_viewmodel = GetPropEntity(GetHale(), "m_hViewModel")
    local sequenceId = main_viewmodel.LookupSequence(animation);
    if (main_viewmodel.GetSequence() != sequenceId)
        main_viewmodel.SetSequence(sequenceId)
}