//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

enum HALE_JUMP_STATUS
{
    WALKING = 0,
    JUMP_STARTED = 1,
    CAN_DOUBLE_JUMP = 2,
    DOUBLE_JUMPED = 3
};

class BraveJumpHaleAbility extends HaleChange
{
    jumpStatus = HALE_JUMP_STATUS.WALKING;

    function OnFrameTick()
    {
        local buttons = GetPropInt(hale, "m_nButtons");

        if (!(hale.GetFlags() & Constants.FPlayer.FL_ONGROUND))
        {
            if (jumpStatus == HALE_JUMP_STATUS.WALKING)
                jumpStatus = HALE_JUMP_STATUS.JUMP_STARTED;
            else if (jumpStatus == HALE_JUMP_STATUS.JUMP_STARTED && !(buttons & Constants.FButtons.IN_JUMP))
                jumpStatus = HALE_JUMP_STATUS.CAN_DOUBLE_JUMP;
        }
        else
            jumpStatus = HALE_JUMP_STATUS.WALKING;

        if (buttons & Constants.FButtons.IN_JUMP && jumpStatus == HALE_JUMP_STATUS.CAN_DOUBLE_JUMP)
        {
            if (!vsh_vscript.IsRoundSetup())
                vsh_vscript.EmitPlayerVO(hale, "jump");

            jumpStatus = HALE_JUMP_STATUS.DOUBLE_JUMPED;
            Perform();
        }
    }

    function Perform()
    {
        local buttons = GetPropInt(hale, "m_nButtons");
        local eyeAngles = hale.EyeAngles();
        local forward = eyeAngles.Forward();
        forward.z = 0;
        forward.Norm();
        local left = eyeAngles.Left();
        left.z = 0;
        left.Norm();

        local forwardmove = 0
        if (buttons & Constants.FButtons.IN_FORWARD)
            forwardmove = 1;
        else if (buttons & Constants.FButtons.IN_BACK)
            forwardmove = -1;
        local sidemove = 0
        if (buttons & Constants.FButtons.IN_MOVELEFT)
            sidemove = -1;
        else if (buttons & Constants.FButtons.IN_MOVERIGHT)
            sidemove = 1;

        local newVelocity = Vector(0,0,0);
        newVelocity.x = forward.x * forwardmove + left.x * sidemove;
        newVelocity.y = forward.y * forwardmove + left.y * sidemove;
        newVelocity.Norm();
        newVelocity *= 300;
        newVelocity.z = vsh_vscript.haleJumpForce

        local currentVelocity = hale.GetAbsVelocity();
        if (currentVelocity.z < 300)
            currentVelocity.z = 0;

        SetPropEntity(hale, "m_hGroundEntity", null);
        hale.SetAbsVelocity(currentVelocity + newVelocity)
    }
}
characterChangesClasses.push(BraveJumpHaleAbility);