//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class TauntHandlerHaleChange extends HaleChange
{
    isTaunting = false;
    isRPSing = false;

    function OnFrameTick()
    {
        if (!hale.InCond(Constants.ETFCond.TF_COND_TAUNTING))
        {
            isTaunting = false;
            return;
        }
        local tauntId = GetPropInt(hale, "m_iTauntItemDefIndex");
        if (tauntId == 463) //Schadenfreude
        {
            if (!isTaunting)
            {
                vsh_vscript.EmitPlayerVO(hale, "laugh");
                isTaunting = true;
            }
        }
        else if (tauntId == 1110) //RPS
        {
            /*if (!isRPSing && GetPropEntity(hale, "m_hHighFivePartner"))
            {
                vsh_vscript.EmitPlayerVO(hale, "rps_123");
                isRPSing = true;
            }*/ //todo need better timings
            if (!isTaunting)
            {
                vsh_vscript.EmitPlayerVO(hale, "rps_init");
                isTaunting = true;
            }
        }
        else
            isTaunting = false;
        if (allowedTaunts.find(tauntId) == null)
            hale.RemoveCond(Constants.ETFCond.TF_COND_TAUNTING);
    }

    //Only Valve-made taunts for copyright reasons.
    //Commented-out taunts aren't animated properly.
    static allowedTaunts = [
        -1,
        167 //High Five!
		438 //Director's Vision
		463 //Schadenfreude
		//1106 //Square Dance
		1107 //Flippin' Awesome
		1110 //Rock, Paper, Scissors
		1118 //Conga
		1157 //Kazotsky Kick
		1162 //Mannrobics
		//1172 //Victory Lap
		//1182 //Yeti Punch
		//1183 //Yeti Smash
    ];
}
characterChangesClasses.push(TauntHandlerHaleChange);