//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class SpyBackstabChange extends CharacterChange
{
    function CanApply()
    {
        return player.GetPlayerClass() == TF_CLASS.SPY;
    }

    function OnDamageDealt(params)
    {
        //Le backstabe
        if (params.damage_custom == Constants.ETFDmgCustom.TF_DMG_CUSTOM_BACKSTAB)
        {
            local hale = params.const_entity;
            params.damage = vsh_vscript.CalcStabDamage() / 2.5; //Crit compensation

            SetPropFloat(params.weapon, "m_flNextPrimaryAttack", Time() + 2.0);
            SetPropFloat(player, "m_flNextAttack", Time() + 2.0);
            SetPropFloat(player, "m_flStealthNextChangeTime", Time() + 2.0);
            EmitSoundOn("Player.Spy_Shield_Break", hale);
            EmitSoundOn("Player.Spy_Shield_Break", hale);
            PlayAnnouncerVO(GetCurrentCharacterName(hale), "pain");
            //EmitSoundOn("Game.HappyBirthdayNoiseMaker", attacker);

            if (WeaponIs(params.weapon, "kunai"))
            {
                player.SetHealth(clampCeiling(270, player.GetHealth() + 180));
            }
            else if (WeaponIs(params.weapon, "big_earner"))
            {
                player.AddCondEx(Constants.ETFCond.TF_COND_SPEED_BOOST, 3, player);
                player.SetSpyCloakMeter(clampFloor(100, player.GetSpyCloakMeter() + 30));
            }
            else if (WeaponIs(params.weapon, "your_eternal_reward") || WeaponIs(params.weapon, "wanga_prick"))
            {
                RunWithDelay("YERDisguise(activator)", player, 0.1);
            }
        }
    }
}
characterChangesClasses.push(SpyBackstabChange);

function YERDisguise(player)
{
    local teammate = null;
    for (local i = 1; i <= Constants.Server.MAX_PLAYERS; i++)
    {
        teammate = PlayerInstanceFromIndex(i);
        if (teammate != player && IsMercAlive(teammate))
            break;
    }
    if (teammate == null)
        return;
    SetPropEntity(player, "m_hDisguiseTarget", teammate);
    SetPropInt(player, "m_nDisguiseTeam", teammate.GetTeam());
    SetPropInt(player, "m_nDisguiseClass", teammate.GetPlayerClass());
    SetPropInt(player, "m_nDisguiseHealth", teammate.GetHealth());
    player.AddCond(Constants.ETFCond.TF_COND_DISGUISED);
    //todo this is buggy
}