//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

::SAXTON_HALE_MODEL_PATH <- "models/player/saxton_hale.mdl"
::SAXTON_HALE_GLOVES_MODEL_PATH <- "models/player/items/vsh_effect_arm_aura.mdl"
::SAXTON_HALE_GLOVES2_MODEL_PATH <- "models/player/items/vsh_effect_arm_aura_megapunch.mdl"
::SAXTON_HALE_GLOW_MODEL_PATH <- "models/player/items/vsh_effect_body_aura.mdl"
::SAXTON_HALE_DASH_MODEL_PATH <- "models/player/items/vsh_dash_effect.mdl"
::SAXTON_HALE_WINDUP_MODEL_PATH <- "models/player/items/vsh_effect_dash_charge.mdl"
::SAXTON_ARMS_MODEL_PATH <- "models/weapons/c_models/c_saxton_arms.mdl"
::SAXTON_ARMS_MODEL_INDEX <- GetModelIndex("models/weapons/c_models/c_saxton_arms.mdl")

function CacheAssets(void)
{
    PrecacheModel(SAXTON_HALE_MODEL_PATH);
    PrecacheModel(SAXTON_HALE_GLOVES_MODEL_PATH);
    PrecacheModel(SAXTON_HALE_GLOVES2_MODEL_PATH);
    PrecacheModel(SAXTON_HALE_GLOW_MODEL_PATH);
    PrecacheModel(SAXTON_HALE_DASH_MODEL_PATH);
    PrecacheModel(SAXTON_HALE_WINDUP_MODEL_PATH);
    PrecacheModel(SAXTON_ARMS_MODEL_PATH);
    PrecacheEntityFromTable({ classname = "info_particle_system", effect_name = "vsh_megapunch_shockwave" })

    self.PrecacheSoundScript("VSH.Slam.ImpactSFX");
    self.PrecacheSoundScript("DemoCharge.HitFlesh");

    self.PrecacheSoundScript("VSH.ChargeSFX");
    self.PrecacheSoundScript("VSH.DashSFX");
    self.PrecacheSoundScript("VSH.PunchSFX");
}
CacheAssets(null);